public interface ISongValidator
{
    Task<Song> ValidateAsync(Uri songUri);

    Task<bool> CanValidateUriAsync(Uri songUri);

    Task<bool> CanExtractSongMetadataAsync(Uri songUri);

    SongProvider GetSongProvider();
}